#include <cstdio>
#include <cstring>
#include <iostream>
#include <cmath>

using namespace std;

int p[110][110], mem[110][110];

int dp(int x, int y){
    int i, j, k;
    int ret = 0;
    if(mem[x][y] != -1)
        return mem[x][y];
    int dir[4][2] = {{0, 1}, {0, -1}, {-1, 0}, {1, 0}};
    for(i = 0; i < 4; i ++){
            if(p[x+dir[i][0]][y+dir[i][1]] == -1)
                continue;
            if(p[x+dir[i][0]][y+dir[i][1]] < p[x][y])
                ret = max (ret, dp(x+dir[i][0], y+dir[i][1]));
    }
    return mem[x][y] = ret + 1;
}

int main(){
    int r, c;
    int i, j, k;
    int ans, tmp;
    while(cin >> r >>c){
        memset(p, -1, sizeof(p));
        memset(mem, -1, sizeof(mem));
        ans = 0;
        for(i = 1; i <= r; i ++)
        for(j = 1; j <= c; j ++){
            mem[i][j] = -1;
            scanf("%d", &p[i][j]);
        }
        for(i = 1; i <= r; i ++)
        for(j = 1; j <= c; j ++){
            tmp = dp(i, j);
            if(tmp > ans)
                ans = tmp;
        }
        cout << ans << endl;
    }
    return 0;
}